    var notificationCenter = (function NotificationCenter() {

        return {
            clear: function() {
                return cordova.exec(arguments[0].callback, null,"MPushPlugin","notificationCenterClear",[]);
            },

            lastOne: function() {
                return cordova.exec(arguments[0].callback, null,"MPushPlugin","notificationCenterLastOne",[]);
            },

            badge: function( ) {
                if ( arguments[0].badge == null) {
                    return cordova.exec(arguments[0].callback, null,"MPushPlugin","notificationCenterGetBadgeNumber",[]);
                }

                return cordova.exec(arguments[0].callback, null,"MPushPlugin","notificationCenterSetBadgeNumber",[arguments[0].badge]);
            },
        };
    })();

    var remotePushNetworkManager = (function RemotePushNetworkManager() {
        return {
            registerService: function( ) {
                return cordova.exec(arguments[0].callback, null,"MPushPlugin","registerService",[arguments[0]]);
            },

            registerUser: function( ) {
                return cordova.exec(arguments[0].callback, null,"MPushPlugin","registerUser",[arguments[0]]);
            },

            registerServiceAndUser: function() {
                return cordova.exec(arguments[0].callback, null,"MPushPlugin","registerServiceAndUser",[arguments[0]]);
            },

            unregisterService: function() {
                return cordova.exec(arguments[0].callback, null,"MPushPlugin","unRegisterService",[arguments[0]]);
            },
            
            unregisterUser: function() {
                return cordova.exec(arguments[0].callback, null,"MPushPlugin","unRegisterUser",[arguments[0]]);
            },

            read: function() {
                return cordova.exec(arguments[0].callback, null,"MPushPlugin","readNotification",[arguments[0]]);
            },

            setBadge: function() {
                return cordova.exec(arguments[0].callback, null,"MPushPlugin","remoteSetBadgeNumber",[arguments[0]]);
            },

            send: function() {
                return cordova.exec(arguments[0].callback, null,"MPushPlugin","sendNotification",[arguments[0]]);
            },
            
            registerGroup: function( ) {
                return cordova.exec(arguments[0].callback, null,"MPushPlugin","registerGroup",[arguments[0]]);
            },

            unregisterGroup: function( ) {
                return cordova.exec(arguments[0].callback, null,"MPushPlugin","unRegisterGroup",[arguments[0]]);
            },

            enabled: function() {
                return cordova.exec(null, null,"MPushPlugin","setEnabled",[arguments[0]]);
            }
        };
    })();


    var MPushPlugin = function() {

    };

    MPushPlugin.prototype.notificationCenter = notificationCenter

    MPushPlugin.prototype.remote = remotePushNetworkManager

    module.exports = new MPushPlugin();

    remotePushNetworkManager.enabled(true)
